=== debian/changelog ===
routerkeygenpc (1.1.0+git20190721.c1f1665-0kali2) kali-dev; urgency=medium

  * Use CMAKE_BUILD_TYPE=Release instead of Debug

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 08 Jun 2021 14:32:03 +0200

routerkeygenpc (1.1.0+git20190721.c1f1665-0kali1) kali-dev; urgency=medium

  * Initial release (see 4082)

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 31 May 2021 16:08:42 +0200
