=== debian/control ===
Source: routerkeygenpc
Section: misc
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Build-Depends: debhelper-compat (= 13), cmake, libssl-dev, qtscript5-dev, qttools5-dev, qttools5-dev-tools, libnm-dev, libglib2.0-dev, pkg-config
Standards-Version: 4.5.1
Homepage: https://github.com/routerkeygen/routerkeygenPC
Vcs-Browser: https://gitlab.com/kalilinux/packages/routerkeygenpc
Vcs-Git: https://gitlab.com/kalilinux/packages/routerkeygenpc.git
Rules-Requires-Root: no

Package: routerkeygenpc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Router Keygen generate default WPA/WEP keys
 This package generates default WPA/WEP keys for the several routers:
  * Thomson based routers ( this includes Thomson, SpeedTouch, Orange,
    Infinitum, BBox, DMax, BigPond, O2Wireless, Otenet, Cyta , TN_private,
    Blink )
  * DLink ( only some models )
  * Pirelli Discus
  * Eircom
  * Verizon FiOS ( only some routers supported)
  * Alice AGPF
  * FASTWEB Pirelli and Telsey
  * Huawei (some InfinitumXXXX)
  * Wlan_XXXX or Jazztel_XXXX
  * Wlan_XX ( only some are supported)
  * Ono ( P1XXXXXX0000X )
  * WlanXXXXXX, YacomXXXXXX and WifiXXXXXX
  * Sky V1 routers
  * Clubinternet.box v1 and v2 ( TECOM-AH4XXXX )
  * InfostradaWifi
  * CONN-X
  * Megared
  * EasyBox, Arcor and Vodafone
  * PBS (Austria)
  * MAXCOM
  * PTV
  * TeleTu/Tele2
  * Axtel, Axtel-xtremo
  * Intercable
  * OTE
  * Cabovisao Sagem
  * Alice in Germany
  * Speedport
