=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
# export DH_VERBOSE = 1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release

override_dh_auto_build:
	dh_auto_build
	cd cli && qmake && make
