=== debian/tests/control ===
Test-Command: routerkeygen-cli -h
Restrictions: superficial
