=== debian/watch ===
version=4
opts="mode=git, pretty=1.1.0+git%cd.%h, pgpmode=none" \
   https://github.com/routerkeygen/routerkeygenPC.git \
   HEAD debian uupdate
